<template>
  <div class="message-container position-relative ml-3 w-100"
        :shown="shown">
    <div class="speak-point position-absolute" />

    <div  class="center-container bg-light text-dark py-2 px-3 rounded shadow w-100">
      {{currentMessage}}
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex'

export default {
  name: 'message',
  data () {
    return {
      shown: true,
      currentMessage: null
    }
  },
  computed: {
    ...mapState(['botMessage'])
  },
  watch: {
    botMessage (newMessage) {
      this.shown = false

      setTimeout(() => {
        this.shown = true
        this.currentMessage = newMessage
      }, 500)
    }
  }
}
</script>

<style lang="scss" scoped>
.speak-point {
  $size: 10px;
  width: $size;
  height: $size;
  left: calc(-1 * #{$size} / 2);
  top: calc(25px - #{$size} / 2);

  transform: rotate(45deg);
  background-color: #F8F9FA;
}

.message-container {
  opacity: 0;
  transition: opacity 500ms ease-in-out;

  &[shown] {
    opacity: 1;
  }
}
</style>
